# IP

## Généralités

IP (Internet Protocol) est le protocole principal de communication sur l'internet, actuellement deux versions sont en cours d'utilisation : IPv4 et IPv6.

IP permet de transmettre des datagrammes d'un point à un autre.

### Adressage

Les adresses IP sont alloués avec la méthode du CIDR (Classless Inter-Domain Routing). Cette méthode consiste à noter une adresse au format `adresse/longueur_préfixe`, elle induit une attribution des IP par blocs.

Les `n` bits (où `n` est la longueur du préfixe) les plus significatifs servent à identifier le réseau auquel l'adresse appartient.

## IPv4

Une adresse IPv4 s'écrit sur 32 bits et utilise une notation décimale pointée (4 entiers séparés par des `.`), par exemple `192.168.0.1` est une adresse IPv4.

De même `192.168.0.0/24` est un exemple de notation CIDR pour un sous-réseau IPv4.

Dans un réseau local les adresses IPv4 peuvent être attribuées par le protocole DHCP ou configurées statiquement.

À noter que dans un sous-réseau IPv4 la première et la dernière sont réservées respectivement pour identifier le réseau et effectuer du broadcast.

## IPv6

Une adresse IPv6 s'écrit sur 128 bits et utilise une notation hexadécimale séparée par des `:` (deux-points), par exemple `2001:0db8:0000:0000:0000:0000:0000:0000` (on regroupe les octets par groupe de 2).

Il existe également une notation compacte pour les adresses IPv6 : on peut omettre les 0 en début de bloc et remplacé le plus longue suite de blocs nuls par `::`, par exemple l'adresse précédente peut s'écrire `2001:db8::`.

Ainsi `2001:db8::/32` est un exemple de notation CIDR pour un sous-réseau IPv6.

Dans un réseau local les adresses IPv6 peuvent être attribuées par le protocole NDP, par le protocole DHCPv6 ou configurées statiquement.

## ip

Sous Linux la commande privilégiée pour consulter l'état de la configuration réseau est `ip` (fournie par la suite `iproute2`) voici quelques exemples de commandes :

Afficher l'état des interfaces de la machine (adresses IP attribuées et leur sous-réseau) :
```bash
ip address
```

Afficher l'état des routes IPv4 de la machine :
```bash
ip route
```

Afficher l'état des routes IPv6 de la machine :
```bash
ip -6 route
```
